<?php
namespace TecFood\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use TecFood\Services\ConfirmaRecebimentoAFService as ConfirmaRecebimentoAFService;

class ConfirmaRecebimentoAF {

	private $environment;
	protected $connection;
	protected $confirmaRecebimentoAFService;

	public function __construct($environment, $connection, ConfirmaRecebimentoAFService $confirmaRecebimentoAFService) {
		$this->environment = $environment;
		$this->connection = $connection;
		$this->confirmaRecebimentoAFService = $confirmaRecebimentoAFService;
	}
	
	public function idAutPerfAcesso(DTO\Request $request, DTO\Response $response){
		try {
			$row = $request->getRow();
            $idautperfacesso = $this->confirmaRecebimentoAFService->returnIdAutPerfAcesso($row);
            $data = array(
	                "IDAUTPERFACESSO" => $idautperfacesso
	        );
	        $response->addDataSet(new DataSet("data", $data));
		} catch(\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
	}

	public function verifyParamIdutlconfrecaf(DTO\Request $request, DTO\Response $response) {
		try {
			$row = $request->getRow();
			$idutlconfrecaf = $this->confirmaRecebimentoAFService->returnParamIdutlconfrecaf($row[0]['CDFILIAL']);
			$data = array(
	                "IDUTLCONFRECAF" => $idutlconfrecaf
	        );
	        $response->addDataSet(new DataSet("data", $data));
		} catch(\Exception $e) {
	            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
	}
	
	public function updateStatusAF(DTO\Request $request, DTO\Response $response){
		try {
			$rows = $request->getRow();
			$cdOperador = $this->environment->getCurrentUserId();
			$this->connection->beginTransaction();
			foreach($rows as $row){
				if($row['IDCONFRECEBIMENTO'] === 'Entrega Total'){
                    $row['IDCONFRECEBIMENTO'] = 'T';
                }else if($row['IDCONFRECEBIMENTO'] === 'Entrega Parcial'){
                    $row['IDCONFRECEBIMENTO'] = 'P';
                }else if($row['IDCONFRECEBIMENTO'] === 'Não Entregue'){
                    $row['IDCONFRECEBIMENTO'] = 'N';
                }else{
                    $row['IDCONFRECEBIMENTO'] = 'D';
                }
                $this->confirmaRecebimentoAFService->updateStatusAF($row, $cdOperador);
			}
			$this->connection->commit();
		} catch(\Exception $e) {
			$this->connection->rollback();
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
	}

}